diff -Naurb u-boot-orig/board/altera/dk1c20/dk1c20.c u-boot-new/board/altera/dk1c20/dk1c20.c
--- u-boot-orig/board/altera/dk1c20/dk1c20.c	2004-02-10 01:12:25.000000000 +0200
+++ u-boot-new/board/altera/dk1c20/dk1c20.c	2004-11-10 16:41:03.000000000 +0200
@@ -2,6 +2,9 @@
  * (C) Copyright 2003, Psyent Corporation <www.psyent.com>
  * Scott McNutt <smcnutt@psyent.com>
  *
+ * CompactFlash/IDE:
+ * (C) Copyright 2004, Shlomo Kut <skut@vyyo.com> 
+ *
  * See file CREDITS for list of people who contributed to this
  * project.
  *
@@ -22,6 +25,7 @@
  */
 
 #include <common.h>
+#include <nios-io.h>
 #if	defined(CONFIG_SEVENSEG)
 #include "../common/sevenseg.h"
 #endif
@@ -50,3 +54,28 @@
 {
 	return (0);
 }
+
+#if (CONFIG_COMMANDS & CFG_CMD_IDE)
+int ide_preinit (void)
+{   
+    nios_pio_t *present = (nios_pio_t *)CFG_CF_PRESENT;
+    nios_pio_t *power = (nios_pio_t *)CFG_CF_POWER;
+    nios_pio_t *atasel = (nios_pio_t *)CFG_CF_ATASEL;
+
+    /* setup data direction registers */
+    present->direction = NIOS_PIO_IN;
+    power->direction = NIOS_PIO_OUT;
+    atasel->direction = NIOS_PIO_OUT;
+
+    /* Check for presence of card */
+    if (present->data)
+        return 1;
+    printf("Ok\n");
+
+    /* Finish setup */
+    power->data = 1;		/* Turn on power FET */
+    atasel->data = 0;		/* Put in ATA mode */
+
+    return 0;
+}
+#endif /* CONFIG_COMMANDS & CFG_CMD_IDE */
diff -Naurb u-boot-orig/board/altera/dk1c20/dk1c20.c.rej u-boot-new/board/altera/dk1c20/dk1c20.c.rej
--- u-boot-orig/board/altera/dk1c20/dk1c20.c.rej	1970-01-01 02:00:00.000000000 +0200
+++ u-boot-new/board/altera/dk1c20/dk1c20.c.rej	2004-11-11 09:19:11.000000000 +0200
@@ -0,0 +1,68 @@
+***************
+*** 2,7 ****
+   * (C) Copyright 2003, Psyent Corporation <www.psyent.com>
+   * Scott McNutt <smcnutt@psyent.com>
+   *
+   * See file CREDITS for list of people who contributed to this
+   * project.
+   *
+--- 2,10 ----
+   * (C) Copyright 2003, Psyent Corporation <www.psyent.com>
+   * Scott McNutt <smcnutt@psyent.com>
+   *
++  * CompactFlash/IDE:
++  * (C) Copyright 2004, Shlomo Kut <skut@vyyo.com> 
++  *
+   * See file CREDITS for list of people who contributed to this
+   * project.
+   *
+***************
+*** 22,27 ****
+   */
+  
+  #include <common.h>
+  #if	defined(CONFIG_SEVENSEG)
+  #include "../common/sevenseg.h"
+  #endif
+--- 25,31 ----
+   */
+  
+  #include <common.h>
++ #include <nios-io.h>
+  #if	defined(CONFIG_SEVENSEG)
+  #include "../common/sevenseg.h"
+  #endif
+***************
+*** 50,52 ****
+  {
+  	return (0);
+  }
+--- 54,81 ----
+  {
+  	return (0);
+  }
++ 
++ #if (CONFIG_COMMANDS & CFG_CMD_IDE)
++ int ide_preinit (void)
++ {   
++     nios_pio_t *present = (nios_pio_t *)CFG_CF_PRESENT;
++     nios_pio_t *power = (nios_pio_t *)CFG_CF_POWER;
++     nios_pio_t *atasel = (nios_pio_t *)CFG_CF_ATASEL;
++ 
++     /* setup data direction registers */
++     present->direction = NIOS_PIO_IN;
++     power->direction = NIOS_PIO_OUT;
++     atasel->direction = NIOS_PIO_OUT;
++ 
++     /* Check for presence of card */
++     if (present->data)
++         return 1;
++     printf("Ok\n");
++ 
++     /* Finish setup */
++     power->data = 1;		/* Turn on power FET */
++     atasel->data = 0;		/* Put in ATA mode */
++ 
++     return 0;
++ }
++ #endif /* CONFIG_COMMANDS & CFG_CMD_IDE */
diff -Naurb u-boot-orig/fs/fat/fat.c u-boot-new/fs/fat/fat.c
--- u-boot-orig/fs/fat/fat.c	2004-09-30 00:55:15.000000000 +0200
+++ u-boot-new/fs/fat/fat.c	2005-01-09 10:24:18.000000000 +0200
@@ -717,12 +717,13 @@
 }
 
 
-__u8 do_fat_read_block[MAX_CLUSTSIZE];  /* Block buffer */
+static __u8 do_fat_read_block[MAX_CLUSTSIZE];  /* Block buffer */
+static char fnamecopy[2048];
+
 static long
 do_fat_read (const char *filename, void *buffer, unsigned long maxsize,
 	     int dols)
 {
-    char fnamecopy[2048];
     boot_sector bs;
     volume_info volinfo;
     fsdata datablock;
diff -Naurb u-boot-orig/include/asm-nios/io.h u-boot-new/include/asm-nios/io.h
--- u-boot-orig/include/asm-nios/io.h	2003-10-09 01:26:15.000000000 +0200
+++ u-boot-new/include/asm-nios/io.h	2004-11-11 09:25:14.000000000 +0200
@@ -1 +1,100 @@
-/*FIXME: Implement this! */
+/*
+ * (C) Copyright 2003, Psyent Corporation <www.psyent.com>
+ * Scott McNutt <smcnutt@psyent.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+#ifndef __ASM_NIOS_IO_H_
+#define __ASM_NIOS_IO_H_
+
+#define readb(addr)\
+	({unsigned char val;\
+	 asm volatile(  "	pfxio	0		\n"\
+		 	"	ld	%0, [%1]	\n"\
+			"	ext8d	%0, %1		\n"\
+			:"=r"(val) : "r" (addr)); val;})
+
+#define readw(addr)\
+	({unsigned short val;\
+	 asm volatile(  "	pfxio	0		\n"\
+		 	"	ld	%0, [%1]	\n"\
+			"	ext16d	%0, %1		\n"\
+			:"=r"(val) : "r" (addr)); val;})
+
+#define readl(addr)\
+	({unsigned long val;\
+	 asm volatile(  "	pfxio	0		\n"\
+		 	"	ld	%0, [%1]	\n"\
+			:"=r"(val) : "r" (addr)); val;})
+	
+#define writeb(addr,val)\
+	asm volatile (	"	fill8	%%r0, %1	\n"\
+			"	st8d	[%0], %%r0	\n"\
+			: : "r" (addr), "r" (val) : "r0")
+	
+#define writew(addr,val)\
+	asm volatile (	"	fill16	%%r0, %1	\n"\
+			"	st16d	[%0], %%r0	\n"\
+			: : "r" (addr), "r" (val) : "r0")
+	
+#define writel(addr,val)\
+	asm volatile (	"	st	[%0], %1	\n"\
+			: : "r" (addr), "r" (val))
+
+#define inb(addr)	readb(addr)
+#define inw(addr)	readw(addr)
+#define inl(addr)	readl(addr)
+#define outb(val,addr)	writeb(addr,val)
+#define outw(val,addr)	writew(addr,val)
+#define outl(val,addr)	writel(addr,val)
+	
+static inline void insb (unsigned long port, void *dst, unsigned long count)
+{
+	unsigned char *p = dst;
+	while (count--) *p++ = inb (port);
+}
+static inline void insw (unsigned long port, void *dst, unsigned long count)
+{
+	unsigned short *p = dst;
+	while (count--) *p++ = inw (port);
+}
+static inline void insl (unsigned long port, void *dst, unsigned long count)
+{
+	unsigned long *p = dst;
+	while (count--) *p++ = inl (port);
+}
+
+static inline void outsb (unsigned long port, const void *src, unsigned long count)
+{
+	const unsigned char *p = src;
+	while (count--) outb (*p++, port);
+}
+
+static inline void outsw (unsigned long port, const void *src, unsigned long count)
+{
+	const unsigned short *p = src;
+	while (count--) outw (*p++, port);
+}
+static inline void outsl (unsigned long port, const void *src, unsigned long count)
+{
+	const unsigned long *p = src;
+	while (count--) outl (*p++, port);
+}
+
+#endif /* __ASM_NIOS_IO_H_ */
diff -Naurb u-boot-orig/include/configs/DK1C20.h u-boot-new/include/configs/DK1C20.h
--- u-boot-orig/include/configs/DK1C20.h	2004-06-09 12:15:02.000000000 +0200
+++ u-boot-new/include/configs/DK1C20.h	2005-01-09 10:37:10.000000000 +0200
@@ -3,6 +3,9 @@
  * Scott McNutt <smcnutt@psyent.com>
  * Stephan Linz <linz@li-pro.net>
  *
+ * CompactFlash/IDE:
+ * (C) Copyright 2004, Shlomo Kut <skut@vyyo.com> 
+ *
  * See file CREDITS for list of people who contributed to this
  * project.
  *
@@ -482,6 +485,29 @@
 #include <cmd_confdefs.h>
 
 /*------------------------------------------------------------------------
+ * COMPACT FLASH
+ *----------------------------------------------------------------------*/
+#if (CONFIG_COMMANDS & CFG_CMD_IDE)
+#define CONFIG_IDE_PREINIT			/* Implement id_preinit	*/
+#define CFG_IDE_MAXBUS		1		/* 1 IDE bus		*/
+#define CFG_IDE_MAXDEVICE	1		/* 1 drive per IDE bus	*/
+
+#define CFG_ATA_BASE_ADDR	0x00920a00	/* IDE/ATA base addr	*/
+#define CFG_ATA_IDE0_OFFSET	0x0000		/* IDE0 offset		*/
+#define CFG_ATA_DATA_OFFSET	0x0040		/* Data IO offset	*/
+#define CFG_ATA_REG_OFFSET	0x0040		/* Register offset	*/
+#define CFG_ATA_ALT_OFFSET	0x0100		/* Alternate reg offset	*/
+#define CFG_ATA_STRIDE          4		/* Width betwix addrs	*/
+#define CONFIG_DOS_PARTITION
+
+/* Board-specific cf regs */
+#define CFG_CF_PRESENT		0x009209b0	/* CF Present PIO base	*/
+#define CFG_CF_POWER		0x009209c0	/* CF Power FET PIO base*/
+#define CFG_CF_ATASEL		0x009209d0	/* CF ATASEL PIO base	*/
+
+#endif /* CONFIG_COMMANDS & CFG_CMD_IDE */
+
+/*------------------------------------------------------------------------
  * KGDB
  *----------------------------------------------------------------------*/
 #if (CONFIG_COMMANDS & CFG_CMD_KGDB)
diff -Naurb u-boot-orig/include/configs/DK1C20.h.rej u-boot-new/include/configs/DK1C20.h.rej
--- u-boot-orig/include/configs/DK1C20.h.rej	1970-01-01 02:00:00.000000000 +0200
+++ u-boot-new/include/configs/DK1C20.h.rej	2004-11-11 09:19:13.000000000 +0200
@@ -0,0 +1,56 @@
+***************
+*** 3,8 ****
+   * Scott McNutt <smcnutt@psyent.com>
+   * Stephan Linz <linz@li-pro.net>
+   *
+   * See file CREDITS for list of people who contributed to this
+   * project.
+   *
+--- 3,11 ----
+   * Scott McNutt <smcnutt@psyent.com>
+   * Stephan Linz <linz@li-pro.net>
+   *
++  * CompactFlash/IDE:
++  * (C) Copyright 2004, Shlomo Kut <skut@vyyo.com> 
++  *
+   * See file CREDITS for list of people who contributed to this
+   * project.
+   *
+***************
+*** 482,487 ****
+  #include <cmd_confdefs.h>
+  
+  /*------------------------------------------------------------------------
+   * KGDB
+   *----------------------------------------------------------------------*/
+  #if (CONFIG_COMMANDS & CFG_CMD_KGDB)
+--- 485,513 ----
+  #include <cmd_confdefs.h>
+  
+  /*------------------------------------------------------------------------
++  * COMPACT FLASH
++  *----------------------------------------------------------------------*/
++ #if (CONFIG_COMMANDS & CFG_CMD_IDE)
++ #define CONFIG_IDE_PREINIT			/* Implement id_preinit	*/
++ #define CFG_IDE_MAXBUS		1		/* 1 IDE bus		*/
++ #define CFG_IDE_MAXDEVICE	1		/* 1 drive per IDE bus	*/
++ 
++ #define CFG_ATA_BASE_ADDR	0x00920a00	/* IDE/ATA base addr	*/
++ #define CFG_ATA_IDE0_OFFSET	0x0000		/* IDE0 offset		*/
++ #define CFG_ATA_DATA_OFFSET	0x0040		/* Data IO offset	*/
++ #define CFG_ATA_REG_OFFSET	0x0040		/* Register offset	*/
++ #define CFG_ATA_ALT_OFFSET	0x0100		/* Alternate reg offset	*/
++ #define CFG_ATA_STRIDE          4		/* Width betwix addrs	*/
++ #define CONFIG_DOS_PARTITION
++ 
++ /* Board-specific cf regs */
++ #define CFG_CF_PRESENT		0x009209b0	/* CF Present PIO base	*/
++ #define CFG_CF_POWER		0x009209c0	/* CF Power FET PIO base*/
++ #define CFG_CF_ATASEL		0x009209d0	/* CF ATASEL PIO base	*/
++ 
++ #endif /* CONFIG_COMMANDS & CFG_CMD_IDE */
++ 
++ /*------------------------------------------------------------------------
+   * KGDB
+   *----------------------------------------------------------------------*/
+  #if (CONFIG_COMMANDS & CFG_CMD_KGDB)