diff -X ignore -urNpb u-boot-cvs/common/cmd_bdinfo.c u-boot-aps/common/cmd_bdinfo.c
--- u-boot-cvs/common/cmd_bdinfo.c      2004-12-31 10:32:50.000000000 +0100
+++ u-boot-aps/common/cmd_bdinfo.c      2005-02-23 09:18:42.000000000 +0100
@@ -216,14 +216,14 @@ int do_bdinfo ( cmd_tbl_t *cmdtp, int fl
        DECLARE_GLOBAL_DATA_PTR;

        int i;
-       bd_t *bd = gd->bd;
+       bd_t *bd = (bd_t*) gd->bd;

        print_num ("arch_number",       bd->bi_arch_number);
        print_num ("env_t",             (ulong)bd->bi_env);
        print_num ("boot_params",       (ulong)bd->bi_boot_params);

        for (i=0; i<CONFIG_NR_DRAM_BANKS; ++i) {
-               print_num("DRAM bank",  i);
+               print_num("DRAM bank nr",       i);
                print_num("-> start",   bd->bi_dram[i].start);
                print_num("-> size",    bd->bi_dram[i].size);
        }
@@ -236,7 +236,7 @@ int do_bdinfo ( cmd_tbl_t *cmdtp, int fl
                "ip_addr     = ");
        print_IPaddr (bd->bi_ip_addr);
        printf ("\n"
-               "baudrate    = %d bps\n", bd->bi_baudrate);
+               "baudrate    = %u bps\n", bd->bi_baudrate );

        return 0;
 }
diff -X ignore -urNpb u-boot-cvs/include/asm-arm/u-boot.h u-boot-aps/include/asm-arm/u-boot.h
--- u-boot-cvs/include/asm-arm/u-boot.h 2002-11-03 01:33:10.000000000 +0100
+++ u-boot-aps/include/asm-arm/u-boot.h 2005-02-04 15:24:04.000000000 +0100
@@ -30,16 +30,17 @@
 #define _U_BOOT_H_     1

 typedef struct bd_info {
-    int                        bi_baudrate;    /* serial console baudrate */
+    unsigned long      bi_baudrate;    /* serial console baudrate */
     unsigned long      bi_ip_addr;     /* IP Address */
     unsigned char      bi_enetaddr[6]; /* Ethernet adress */
+    unsigned char       pad[2];
     struct environment_s              *bi_env;
-    ulong              bi_arch_number; /* unique id for this board */
-    ulong              bi_boot_params; /* where this board expects params */
+    unsigned long       bi_arch_number;        /* unique id for this board */
+    unsigned long       bi_boot_params;        /* where this board expects params */
     struct                             /* RAM configuration */
     {
-       ulong start;
-       ulong size;
+       unsigned long start;
+       unsigned long size;
     }                  bi_dram[CONFIG_NR_DRAM_BANKS];
 } bd_t;

diff -X ignore -urNpb u-boot-cvs/include/ns16550.h u-boot-aps/include/ns16550.h
--- u-boot-cvs/include/ns16550.h        2005-01-10 00:16:44.000000000 +0100
+++ u-boot-aps/include/ns16550.h        2005-02-04 15:18:20.000000000 +0100
@@ -45,15 +45,15 @@ struct NS16550 {
 } __attribute__ ((packed));
 #elif (CFG_NS16550_REG_SIZE == 4)
 struct NS16550 {
-       unsigned long rbr;              /* 0 */
-       unsigned long ier;              /* 1 */
-       unsigned long fcr;              /* 2 */
-       unsigned long lcr;              /* 3 */
-       unsigned long mcr;              /* 4 */
-       unsigned long lsr;              /* 5 */
-       unsigned long msr;              /* 6 */
-       unsigned long scr;              /* 7 */
-} __attribute__ ((packed));
+       unsigned long rbr;              /* 0 r  */
+       unsigned long ier;              /* 1 rw */
+       unsigned long fcr;              /* 2 w  */
+       unsigned long lcr;              /* 3 rw */
+       unsigned long mcr;              /* 4 rw */
+       unsigned long lsr;              /* 5 r  */
+       unsigned long msr;              /* 6 r  */
+       unsigned long scr;              /* 7 rw */
+}; /* No need to pack an already aligned struct */
 #elif (CFG_NS16550_REG_SIZE == -4)
 struct NS16550 {
        unsigned char rbr;              /* 0 */
@@ -102,7 +102,7 @@ typedef volatile struct NS16550 *NS16550
 #define MCR_DMA_EN      0x04
 #define MCR_TX_DFR      0x08

-#define LCR_WLS_MSK    0x03            /* character length slect mask */
+#define LCR_WLS_MSK    0x03            /* character length select mask */
 #define LCR_WLS_5      0x00            /* 5 bit character length */
 #define LCR_WLS_6      0x01            /* 6 bit character length */
 #define LCR_WLS_7      0x02            /* 7 bit character length */